package com.sa.ibiz.demo.demo.domain;

import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.annotation.TableName;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonIgnoreProperties;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonProperty.Access;
import lombok.Data;
import org.springframework.beans.BeanUtils;
import org.springframework.cglib.beans.BeanMap;
import org.springframework.cglib.beans.BeanGenerator;
import com.baomidou.mybatisplus.annotation.TableLogic;
import com.baomidou.mybatisplus.annotation.TableField;
import com.baomidou.mybatisplus.annotation.FieldFill;
import java.util.Map;
import java.util.HashMap;
import org.springframework.util.StringUtils;
import com.sa.ibiz.demo.ibizutil.security.AuthenticationUser;
import java.util.Date;
import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Size;
import org.springframework.util.DigestUtils;
import org.springframework.util.StringUtils;
import java.util.UUID;
import javax.validation.constraints.NotNull;
import java.io.Serializable;
import org.springframework.cglib.beans.BeanCopier;
import com.sa.ibiz.demo.ibizutil.annotation.Dict;
import com.sa.ibiz.demo.ibizutil.domain.EntityBase;
import java.io.Serializable;
import com.baomidou.mybatisplus.core.toolkit.IdWorker;
import java.math.BigInteger;
import com.sa.ibiz.demo.ibizutil.enums.FillMode;
import com.sa.ibiz.demo.ibizutil.enums.PredefinedType;
import com.sa.ibiz.demo.ibizutil.annotation.PreField;
import com.alibaba.fastjson.annotation.JSONField;

import com.sa.ibiz.demo.demo.domain.TSSDEngine;

/**
 * 实体[TSSDTask] 数据对象
 */
@TableName(value = "T_SRFTSSDTASK",resultMap = "TSSDTaskResultMap")
@JsonIgnoreProperties(ignoreUnknown = true)
@Data
public class TSSDTask extends EntityBase implements Serializable{

    @JSONField(serialize = false)
    @JsonIgnore
    @TableField(exist = false)//关系主表数据
    private TSSDEngine tssdengine;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEDATE)
    private Timestamp createdate;
    @PreField(fill= FillMode.INSERT,preType = PredefinedType.CREATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String createman;
    @Dict(dictName = "ionicdemo_YesNoCodeList")
    private Integer enableflag;
    private String taskparam;
    private String tssdengineid;
    @TableField(exist = false)//逻辑属性
    private String tssdenginename;
    @TableId(value= "tssdtaskid",type=IdType.UUID)//指定主键生成策略
    private String tssdtaskid;
    private String tssdtaskname;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEDATE)
    private Timestamp updatedate;
    @PreField(fill= FillMode.INSERT_UPDATE,preType = PredefinedType.UPDATEMAN)
    @Dict(dictName = "ionicdemo_SysOperatorCodeList")
    private String updateman;
    private String userdata;
    private String userdata2;
    private String userdata3;
    private String userdata4;
    private Integer version;
    /**
     *  设置属性值[建立时间]
     *  @param createdate
     */
    public void setCreatedate(Timestamp createdate){
        this.createdate = createdate;
        this.set("createdatedirtyflag",true);
    }
    /**
     *  获取属性值[建立时间]
     */
    public Timestamp getCreatedate(){
        return this.createdate;
    }
    /**
     *  重置属性值[建立时间]
     */
    public void resetCreatedate(){
        this.set("createdatedirtyflag",false);
        this.createdate = null;
    }
    /**
     *  设置属性值[建立人]
     *  @param createman
     */
    public void setCreateman(String createman){
        if(StringUtils.isEmpty(createman))
            createman=null;
        this.createman = createman;
        this.set("createmandirtyflag",true);
    }
    /**
     *  获取属性值[建立人]
     */
    public String getCreateman(){
        return this.createman;
    }
    /**
     *  重置属性值[建立人]
     */
    public void resetCreateman(){
        this.set("createmandirtyflag",false);
        this.createman = null;
    }
    /**
     *  设置属性值[启用标志]
     *  @param enableflag
     */
    public void setEnableflag(Integer enableflag){
        this.enableflag = enableflag;
        this.set("enableflagdirtyflag",true);
    }
    /**
     *  获取属性值[启用标志]
     */
    public Integer getEnableflag(){
        return this.enableflag;
    }
    /**
     *  重置属性值[启用标志]
     */
    public void resetEnableflag(){
        this.set("enableflagdirtyflag",false);
        this.enableflag = null;
    }
    /**
     *  设置属性值[任务参数]
     *  @param taskparam
     */
    public void setTaskparam(String taskparam){
        if(StringUtils.isEmpty(taskparam))
            taskparam=null;
        this.taskparam = taskparam;
        this.set("taskparamdirtyflag",true);
    }
    /**
     *  获取属性值[任务参数]
     */
    public String getTaskparam(){
        return this.taskparam;
    }
    /**
     *  重置属性值[任务参数]
     */
    public void resetTaskparam(){
        this.set("taskparamdirtyflag",false);
        this.taskparam = null;
    }
    /**
     *  设置属性值[任务调度引擎]
     *  @param tssdengineid
     */
    public void setTssdengineid(String tssdengineid){
        if(StringUtils.isEmpty(tssdengineid))
            tssdengineid=null;
        this.tssdengineid = tssdengineid;
        this.set("tssdengineiddirtyflag",true);
    }
    /**
     *  获取属性值[任务调度引擎]
     */
    public String getTssdengineid(){
        return this.tssdengineid;
    }
    /**
     *  重置属性值[任务调度引擎]
     */
    public void resetTssdengineid(){
        this.set("tssdengineiddirtyflag",false);
        this.tssdengineid = null;
    }
    /**
     *  设置属性值[任务调度引擎]
     *  @param tssdenginename
     */
    public void setTssdenginename(String tssdenginename){
        if(StringUtils.isEmpty(tssdenginename))
            tssdenginename=null;
        this.tssdenginename = tssdenginename;
        this.set("tssdenginenamedirtyflag",true);
    }
    /**
     *  获取属性值[任务调度引擎]
     */
    public String getTssdenginename(){
        return this.tssdenginename;
    }
    /**
     *  重置属性值[任务调度引擎]
     */
    public void resetTssdenginename(){
        this.set("tssdenginenamedirtyflag",false);
        this.tssdenginename = null;
    }
    /**
     *  设置属性值[任务调度任务项标识]
     *  @param tssdtaskid
     */
    public void setTssdtaskid(String tssdtaskid){
        if(StringUtils.isEmpty(tssdtaskid))
            tssdtaskid=null;
        this.tssdtaskid = tssdtaskid;
        this.set("tssdtaskiddirtyflag",true);
    }
    /**
     *  获取属性值[任务调度任务项标识]
     */
    public String getTssdtaskid(){
        return this.tssdtaskid;
    }
    /**
     *  重置属性值[任务调度任务项标识]
     */
    public void resetTssdtaskid(){
        this.set("tssdtaskiddirtyflag",false);
        this.tssdtaskid = null;
    }
    /**
     *  设置属性值[调度任务项名称]
     *  @param tssdtaskname
     */
    public void setTssdtaskname(String tssdtaskname){
        if(StringUtils.isEmpty(tssdtaskname))
            tssdtaskname=null;
        this.tssdtaskname = tssdtaskname;
        this.set("tssdtasknamedirtyflag",true);
    }
    /**
     *  获取属性值[调度任务项名称]
     */
    public String getTssdtaskname(){
        return this.tssdtaskname;
    }
    /**
     *  重置属性值[调度任务项名称]
     */
    public void resetTssdtaskname(){
        this.set("tssdtasknamedirtyflag",false);
        this.tssdtaskname = null;
    }
    /**
     *  设置属性值[更新时间]
     *  @param updatedate
     */
    public void setUpdatedate(Timestamp updatedate){
        this.updatedate = updatedate;
        this.set("updatedatedirtyflag",true);
    }
    /**
     *  获取属性值[更新时间]
     */
    public Timestamp getUpdatedate(){
        return this.updatedate;
    }
    /**
     *  重置属性值[更新时间]
     */
    public void resetUpdatedate(){
        this.set("updatedatedirtyflag",false);
        this.updatedate = null;
    }
    /**
     *  设置属性值[更新人]
     *  @param updateman
     */
    public void setUpdateman(String updateman){
        if(StringUtils.isEmpty(updateman))
            updateman=null;
        this.updateman = updateman;
        this.set("updatemandirtyflag",true);
    }
    /**
     *  获取属性值[更新人]
     */
    public String getUpdateman(){
        return this.updateman;
    }
    /**
     *  重置属性值[更新人]
     */
    public void resetUpdateman(){
        this.set("updatemandirtyflag",false);
        this.updateman = null;
    }
    /**
     *  设置属性值[用户数据]
     *  @param userdata
     */
    public void setUserdata(String userdata){
        if(StringUtils.isEmpty(userdata))
            userdata=null;
        this.userdata = userdata;
        this.set("userdatadirtyflag",true);
    }
    /**
     *  获取属性值[用户数据]
     */
    public String getUserdata(){
        return this.userdata;
    }
    /**
     *  重置属性值[用户数据]
     */
    public void resetUserdata(){
        this.set("userdatadirtyflag",false);
        this.userdata = null;
    }
    /**
     *  设置属性值[用户数据2]
     *  @param userdata2
     */
    public void setUserdata2(String userdata2){
        if(StringUtils.isEmpty(userdata2))
            userdata2=null;
        this.userdata2 = userdata2;
        this.set("userdata2dirtyflag",true);
    }
    /**
     *  获取属性值[用户数据2]
     */
    public String getUserdata2(){
        return this.userdata2;
    }
    /**
     *  重置属性值[用户数据2]
     */
    public void resetUserdata2(){
        this.set("userdata2dirtyflag",false);
        this.userdata2 = null;
    }
    /**
     *  设置属性值[用户数据3]
     *  @param userdata3
     */
    public void setUserdata3(String userdata3){
        if(StringUtils.isEmpty(userdata3))
            userdata3=null;
        this.userdata3 = userdata3;
        this.set("userdata3dirtyflag",true);
    }
    /**
     *  获取属性值[用户数据3]
     */
    public String getUserdata3(){
        return this.userdata3;
    }
    /**
     *  重置属性值[用户数据3]
     */
    public void resetUserdata3(){
        this.set("userdata3dirtyflag",false);
        this.userdata3 = null;
    }
    /**
     *  设置属性值[用户数据4]
     *  @param userdata4
     */
    public void setUserdata4(String userdata4){
        if(StringUtils.isEmpty(userdata4))
            userdata4=null;
        this.userdata4 = userdata4;
        this.set("userdata4dirtyflag",true);
    }
    /**
     *  获取属性值[用户数据4]
     */
    public String getUserdata4(){
        return this.userdata4;
    }
    /**
     *  重置属性值[用户数据4]
     */
    public void resetUserdata4(){
        this.set("userdata4dirtyflag",false);
        this.userdata4 = null;
    }
    /**
     *  设置属性值[版本]
     *  @param version
     */
    public void setVersion(Integer version){
        this.version = version;
        this.set("versiondirtyflag",true);
    }
    /**
     *  获取属性值[版本]
     */
    public Integer getVersion(){
        return this.version;
    }
    /**
     *  重置属性值[版本]
     */
    public void resetVersion(){
        this.set("versiondirtyflag",false);
        this.version = null;
    }
     /**
     *  获取主实体关联数据[TSSDEngine]
     */
    public TSSDEngine getTssdengine() {
        return tssdengine;
    }
    /**
     *  设置主实体关联数据[TSSDEngine]
     */
    public void setTssdengine(TSSDEngine tssdengine) {
        this.tssdengine = tssdengine;
    }

    /**
     * 重置当前数据对象属性值
     */
    public  void reset(){
        resetCreatedate();
        resetCreateman();
        resetEnableflag();
        resetTaskparam();
        resetTssdengineid();
        resetTssdenginename();
        resetTssdtaskid();
        resetTssdtaskname();
        resetUpdatedate();
        resetUpdateman();
        resetUserdata();
        resetUserdata2();
        resetUserdata3();
        resetUserdata4();
        resetVersion();
    }
     /**
     * 获取数据主键（普通主键与联合主键）
     * @return
     */
    @JsonIgnore
    public Serializable getDefaultPrimaryKey()
    {
	    //随机生成主键
         return  IdWorker.get32UUID();

    }
     /**
     * 复制当前对象数据到目标对象(粘贴重置)
     *
     * @throws Exception
     */
    public TSSDTask copyTo(TSSDTask targetEntity)
	{
		BeanCopier copier=BeanCopier.create(TSSDTask.class, TSSDTask.class, false);
		copier.copy(this, targetEntity, null);
        targetEntity.resetTssdtaskid();
		return targetEntity;
	}
}